Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QTextEdit

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.core.QObject
                  com.trolltech.qt.gui.QWidget
                      com.trolltech.qt.gui.QFrame
                          com.trolltech.qt.gui.QAbstractScrollArea
                              com.trolltech.qt.gui.QTextEdit

All Implemented Interfaces:
  QPaintDeviceInterface, QtJambiInterface

Direct Known Subclasses:
  QTextBrowser

    public class QTextEdit

extends QAbstractScrollArea

The `QTextEdit` class provides a widget that is used to edit and display both plain and rich text.

- Introduction and Concepts
- Using QTextEdit as a Display Widget

- Read-only Key Bindings

- Using QTextEdit as an Editor

- Drag and Drop
- Editing Key Bindings

### Introduction and Concepts

`QTextEdit` is an advanced WYSIWYG viewer/editor supporting rich text formatting using HTML-style tags. It is optimized to handle large documents and to respond quickly to user input.

`QTextEdit` works on paragraphs and characters. A paragraph is a formatted string which is word-wrapped to fit into the width of the widget. By default when reading plain text, one newline signifies a paragraph. A document consists of zero or more paragraphs. The words in the paragraph are aligned in accordance with the paragraph's alignment. Paragraphs are separated by hard line breaks. Each character within a paragraph has its own attributes, for example, font and color.

`QTextEdit` can display images, lists and tables. If the text is too large to view within the text edit's viewport, scroll bars will appear. The text edit can load both plain text and HTML files (a subset of HTML 3.2 and 4).

If you just need to display a small piece of rich text use `QLabel`.

Note that we do not intend to add a full-featured web browser widget to Qt (because that would easily double Qt's size and only a few applications would benefit from it). The rich text support in Qt is designed to provide a fast, portable and efficient way to add reasonable online help facilities to applications, and to provide a basis for rich text editors.

The shape of the mouse cursor on a `QTextEdit` is Qt::IBeamCursor by default. It can be changed through the `viewport`'s cursor property.

### Using QTextEdit as a Display Widget

`QTextEdit` can display a large HTML subset, including tables and images.

The text is set or replaced using `setHtml` which deletes any existing text and replaces it with the text passed in the `setHtml` call. If you call `setHtml` with legacy HTML, and then call `toHtml`, the text that is returned may have different markup, but will render the same. The entire text can be deleted with `clear`.

Text itself can be inserted using the `QTextCursor` class or using the convenience functions `insertHtml`, `insertPlainText`, `append` or `paste`. `QTextCursor` is also able to insert complex objects like tables or lists into the document, and it deals with creating selections and applying changes to selected text.

By default the text edit wraps words at whitespace to fit within the text edit widget. The `setLineWrapMode` function is used to specify the kind of line wrap you want, or `NoWrap` if you don't want any wrapping. Call `setLineWrapMode` to set a fixed pixel width `FixedPixelWidth`, or character column (e.g. 80 column) `FixedColumnWidth` with the pixels or columns specified with `setLineWrapColumnOrWidth`. If you use word wrap to the widget's width `WidgetWidth`, you can specify whether to break on whitespace or anywhere with `setWordWrapMode`.

The `find` function can be used to find and select a given string within the text.

If you want to limit the total number of paragraphs in a `QTextEdit`, as it is for example open useful in a log viewer, then you can use `QTextDocument`'s maximumBlockCount property for that.

#### Read-only Key Bindings

When `QTextEdit` is used read-only the key bindings are limited to navigation, and text may only be selected with the mouse:

Keypresses | Action
--- | ---
Qt::UpArrow | Moves one line up.
Qt::DownArrow | Moves one line down.
Qt::LeftArrow | Moves one character to the left.
Qt::RightArrow | Moves one character to the right.
PageUp | Moves one (viewport) page up.
PageDown | Moves one (viewport) page down.
Home | Moves to the beginning of the text.
End | Moves to the end of the text.
Alt+Wheel | Scrolls the page horizontally (the Wheel is the mouse wheel).
Ctrl+Wheel | Zooms the text.
Ctrl+A | Selects all text.

The text edit may be able to provide some meta-information. For example, the `documentTitle` function will return the text from within HTML `<title>` tags.

### Using QTextEdit as an Editor

All the information about using `QTextEdit` as a display widget also applies here.

The current char format's attributes are set with `setFontItalic`, `setFontWeight`, `setFontUnderline`, `setFontFamily`, `setFontPointSize`, `setTextColor` and `setCurrentFont`. The current paragraph's alignment is set with `setAlignment`.

Selection of text is handled by the `QTextCursor` class, which provides functionality for creating selections, retrieving the text contents or deleting selections. You can retrieve the object that corresponds with the user-visible cursor using the `textCursor` method. If you want to set a selection in `QTextEdit` just create one on a `QTextCursor` object and then make that cursor the visible cursor using `setCursor`. The selection can be copied to the clipboard with `copy`, or cut to the clipboard with `cut`. The entire text can be selected using `selectAll`.

When the cursor is moved and the underlying formatting attributes change, the `currentCharFormatChanged` signal is emitted to reflect the new attributes at the new cursor position.

`QTextEdit` holds a `QTextDocument` object which can be retrieved using the `document` method. You can also set your own document object using `setDocument`. `QTextDocument` emits a `textChanged` signal if the text changes and it also provides a isModified() function which will return true if the text has been modified since it was either loaded or since the last call to setModified with false as argument. In addition it provides methods for undo and redo.

#### Drag and Drop

`QTextEdit` also supports custom drag and drop behavior. By default, `QTextEdit` will insert plain text, HTML and rich text when the user drops data of these MIME types onto a document. Reimplement `canInsertFromMimeData` and `insertFromMimeData` to add support for additional MIME types.

For example, to allow the user to drag and drop an image onto a `QTextEdit`, you could the implement these functions in the following way:

        bool TextEdit::canInsertFromMimeData( const QMimeData *source ) const
        {
            if (source->hasImage())
                return true;
            else
                return QTextEdit::canInsertFromMimeData(source);
        }

We add support for image MIME types by returning true. For all other MIME types, we use the default implementation.

        void TextEdit::insertFromMimeData( const QMimeData *source )
        {
            if (source->hasImage())
            {
                QImage image = qvariant_cast<QImage>(source->imageData());
                QTextCursor cursor = this->textCursor();
                QTextDocument *document = this->document();
                document->addResource(QTextDocument::ImageResource, QUrl("image"), image);
                cursor.insertImage("image");
            }
        }

We unpack the image from the `QVariant` held by the MIME source and insert it into the document as a resource.

#### Editing Key Bindings

The list of key bindings which are implemented for editing:

Keypresses | Action
--- | ---
Backspace | Deletes the character to the left of the cursor.
Delete | Deletes the character to the right of the cursor.
Ctrl+C | Copy the selected text to the clipboard.
Ctrl+Insert | Copy the selected text to the clipboard.
Ctrl+K | Deletes to the end of the line.
Ctrl+V | Pastes the clipboard text into text edit.
Shift+Insert | Pastes the clipboard text into text edit.
Ctrl+X | Deletes the selected text and copies it to the clipboard.
Shift+Delete | Deletes the selected text and copies it to the clipboard.
Ctrl+Z | Undoes the last operation.
Ctrl+Y | Redoes the last operation.
LeftArrow | Moves the cursor one character to the left.
Ctrl+LeftArrow | Moves the cursor one word to the left.
RightArrow | Moves the cursor one character to the right.
Ctrl+RightArrow | Moves the cursor one word to the right.
UpArrow | Moves the cursor one line up.
Ctrl+UpArrow | Moves the cursor one word up.
DownArrow | Moves the cursor one line down.
Ctrl+Down Arrow | Moves the cursor one word down.
PageUp | Moves the cursor one page up.
PageDown | Moves the cursor one page down.
Home | Moves the cursor to the beginning of the line.
Ctrl+Home | Moves the cursor to the beginning of the text.
End | Moves the cursor to the end of the line.
Ctrl+End | Moves the cursor to the end of the text.
Alt+Wheel | Scrolls the page horizontally (the Wheel is the mouse wheel).

To select (mark) text hold down the Shift key whilst pressing one of the movement keystrokes, for example, Shift+Right Arrow will select the character to the right, and Shift+Ctrl+Right Arrow will select the word to the right, etc.

See Also:
  `QTextDocument`, `QTextCursor`, Application Example, Syntax Highlighter Example, Rich Text Processing

Nested Class Summary
`static class` | `QTextEdit.AutoFormatting` This QFlag class provides flags for the int enum.
`static class` | `QTextEdit.AutoFormattingFlag` Press link for info on QTextEdit.AutoFormattingFlag
`static class` | `QTextEdit.LineWrapMode` Press link for info on QTextEdit.LineWrapMode

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QFrame
`QFrame.Shadow, QFrame.Shape, QFrame.StyleMask`

Nested classes/interfaces inherited from class com.trolltech.qt.gui.QWidget
`QWidget.RenderFlag, QWidget.RenderFlags`

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1<A>, QSignalEmitter.Signal2<A,B>, QSignalEmitter.Signal3<A,B,C>, QSignalEmitter.Signal4<A,B,C,D>, QSignalEmitter.Signal5<A,B,C,D,E>, QSignalEmitter.Signal6<A,B,C,D,E,F>, QSignalEmitter.Signal7<A,B,C,D,E,F,G>, QSignalEmitter.Signal8<A,B,C,D,E,F,G,H>, QSignalEmitter.Signal9<A,B,C,D,E,F,G,H,I>`

Field Summary
`QSignalEmitter.Signal1<java.lang.Boolean>` | `copyAvailable` This signal is emitted when text is selected or de-selected in the text edit.
`QSignalEmitter.Signal1<QTextCharFormat>` | `currentCharFormatChanged` This signal is emitted if the current character format has changed, for example caused by a change of the cursor position.
`QSignalEmitter.Signal0` | `cursorPositionChanged` This signal is emitted whenever the position of the cursor changed.
`QSignalEmitter.Signal1<java.lang.Boolean>` | `redoAvailable` This signal is emitted whenever redo operations become available (`b` is true) or unavailable (`b` is false).
`QSignalEmitter.Signal0` | `selectionChanged` This signal is emitted whenever the selection changes.
`QSignalEmitter.Signal0` | `textChanged` This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.
`QSignalEmitter.Signal1<java.lang.Boolean>` | `undoAvailable` This signal is emitted whenever undo operations become available (`b` is true) or unavailable (`b` is false).

Fields inherited from class com.trolltech.qt.gui.QWidget
`customContextMenuRequested`

Constructor Summary
`QTextEdit()` Equivalent to `QTextEdit`(0).
`QTextEdit(QWidget parent)` Constructs an empty `QTextEdit` with parent `parent`.
`QTextEdit(java.lang.String text)` Equivalent to `QTextEdit`(`text`, 0).
`QTextEdit(java.lang.String text, QWidget parent)` Constructs a `QTextEdit` with parent `parent`.

Method Summary
`boolean` | `acceptRichText()` Returns whether the text edit accepts rich text insertions by the user.
`Qt.Alignment` | `alignment()` Returns the alignment of the current paragraph.
`java.lang.String` | `anchorAt(QPoint pos)` Returns the reference of the anchor at position `pos`, or an empty string if no anchor exists at that point.
`void` | `append(java.lang.String text)` Appends a new paragraph with `text` to the end of the text edit.
`QTextEdit.AutoFormatting` | `autoFormatting()` Returns the enabled set of auto formatting features.
`protected boolean` | `canInsertFromMimeData(QMimeData source)` This function returns true if the contents of the MIME data object, specified by `source`, can be decoded and inserted into the document.
`boolean` | `canPaste()` Returns whether text can be pasted from the clipboard into the textedit.
`protected void` | `changeEvent(QEvent e)` This function is reimplemented for internal reasons.
`void` | `clear()` Deletes all the text in the text edit.
`protected void` | `contextMenuEvent(QContextMenuEvent e)` Shows the standard context menu created with `createStandardContextMenu`.
`void` | `copy()` Copies any selected text to the clipboard.
`protected QMimeData` | `createMimeDataFromSelection()` This function returns a new MIME data object to represent the contents of the text edit's current selection.
`QMenu` | `createStandardContextMenu()` This function creates the standard context menu which is shown when the user clicks on the line edit with the right mouse button.
`QTextCharFormat` | `currentCharFormat()` Returns the char format that is used when inserting new text.
`QFont` | `currentFont()` Returns the font of the current format.
`QTextCursor` | `cursorForPosition(QPoint pos)` returns a `QTextCursor` at position `pos` (in viewport coordinates).
`QRect` | `cursorRect()` returns a rectangle (in viewport coordinates) that includes the cursor of the text edit.
`QRect` | `cursorRect(QTextCursor cursor)` returns a rectangle (in viewport coordinates) that includes the `cursor`.
`int` | `cursorWidth()` This property specifies the width of the cursor in pixels.
`void` | `cut()` Copies the selected text to the clipboard and deletes it from the text edit.
`QTextDocument` | `document()` Returns a pointer to the underlying document.
`java.lang.String` | `documentTitle()` Returns the title of the document parsed from the text..
`protected void` | `dragEnterEvent(QDragEnterEvent e)` This function is reimplemented for internal reasons.
`protected void` | `dragLeaveEvent(QDragLeaveEvent e)` This function is reimplemented for internal reasons.
`protected void` | `dragMoveEvent(QDragMoveEvent e)` This function is reimplemented for internal reasons.
`protected void` | `dropEvent(QDropEvent e)` This function is reimplemented for internal reasons.
`void` | `ensureCursorVisible()` Ensures that the cursor is visible by scrolling the text edit if necessary.
`boolean` | `event(QEvent e)` This function is reimplemented for internal reasons.
`java.util.List<QTextEdit_ExtraSelection>` | `extraSelections()` Returns previously set extra selections.
`boolean` | `find(java.lang.String exp)` Equivalent to find(`exp`, 0).
`boolean` | `find(java.lang.String exp, QTextDocument.FindFlag... options)` Finds the next occurrence of the string, `exp`, using the given `options`.
`boolean` | `find(java.lang.String exp, QTextDocument.FindFlags options)` Finds the next occurrence of the string, `exp`, using the given `options`.
`protected void` | `focusInEvent(QFocusEvent e)` This function is reimplemented for internal reasons.
`protected boolean` | `focusNextPrevChild(boolean next)` This function is reimplemented for internal reasons.
`protected void` | `focusOutEvent(QFocusEvent e)` This function is reimplemented for internal reasons.
`java.lang.String` | `fontFamily()` Returns the font family of the current format.
`boolean` | `fontItalic()` Returns true if the font of the current format is italic; otherwise returns false.
`double` | `fontPointSize()` Returns the point size of the font of the current format.
`boolean` | `fontUnderline()` Returns true if the font of the current format is underlined; otherwise returns false.
`int` | `fontWeight()` Returns the font weight of the current format.
`static QTextEdit` | `fromNativePointer(QNativePointer nativePointer)` This function returns the QTextEdit instance pointed to by nativePointer
`protected void` | `inputMethodEvent(QInputMethodEvent arg__1)` This function is reimplemented for internal reasons.
`java.lang.Object` | `inputMethodQuery(Qt.InputMethodQuery property)` This function is reimplemented for internal reasons.
`protected void` | `insertFromMimeData(QMimeData source)` This function inserts the contents of the MIME data object, specified by `source`, into the text edit at the current cursor position.
`void` | `insertHtml(java.lang.String text)` Convenience slot that inserts `text` which is assumed to be of html formatting at the current cursor position.
`void` | `insertPlainText(java.lang.String text)` Convenience slot that inserts `text` at the current cursor position.
`boolean` | `isReadOnly()` Returns whether the text edit is read-only.
`boolean` | `isUndoRedoEnabled()` Returns whether undo and redo are enabled.
`protected void` | `keyPressEvent(QKeyEvent e)` This function is reimplemented for internal reasons.
`protected void` | `keyReleaseEvent(QKeyEvent e)` This function is reimplemented for internal reasons.
`int` | `lineWrapColumnOrWidth()` Returns the position (in pixels or columns depending on the wrap mode) where text will be wrapped.
`QTextEdit.LineWrapMode` | `lineWrapMode()` Returns the line wrap mode.
`java.lang.Object` | `loadResource(int type, QUrl name)` Loads the resource specified by the given `type` and `name`.
`void` | `mergeCurrentCharFormat(QTextCharFormat modifier)` Merges the properties specified in `modifier` into the current character format by calling QTextCursor::mergeCharFormat on the editor's cursor.
`protected void` | `mouseDoubleClickEvent(QMouseEvent e)` This function is reimplemented for internal reasons.
`protected void` | `mouseMoveEvent(QMouseEvent e)` This function is reimplemented for internal reasons.
`protected void` | `mousePressEvent(QMouseEvent e)` This function is reimplemented for internal reasons.
`protected void` | `mouseReleaseEvent(QMouseEvent e)` This function is reimplemented for internal reasons.
`void` | `moveCursor(QTextCursor.MoveOperation operation)` Equivalent to `moveCursor`(`operation`, QTextCursor::MoveAnchor).
`void` | `moveCursor(QTextCursor.MoveOperation operation, QTextCursor.MoveMode mode)` Moves the cursor by performing the given `operation`.
`boolean` | `overwriteMode()` Returns this QTextEdit's overwrite mode.
`protected void` | `paintEvent(QPaintEvent e)` This function is reimplemented for internal reasons.
`void` | `paste()` Pastes the text from the clipboard into the text edit at the current cursor position.
`void` | `print(QPrinter printer)` Convenience function to print the text edit's document to the given `printer`.
`void` | `redo()` Redoes the last operation.
`protected void` | `resizeEvent(QResizeEvent e)` This function is reimplemented for internal reasons.
`protected void` | `scrollContentsBy(int dx, int dy)` This function is reimplemented for internal reasons.
`void` | `scrollToAnchor(java.lang.String name)` Scrolls the text edit so that the anchor with the given `name` is visible; does nothing if the `name` is empty, or is already visible, or isn't found.
`void` | `selectAll()` Selects all text.
`void` | `setAcceptRichText(boolean accept)` Sets whether the text edit accepts rich text insertions by the user to `accept`.
`void` | `setAlignment(Qt.Alignment a)` Sets the alignment of the current paragraph to `a`.
`void` | `setAlignment(Qt.AlignmentFlag... a)` Sets the alignment of the current paragraph to `a`.
`void` | `setAutoFormatting(QTextEdit.AutoFormatting features)` Sets the enabled set of auto formatting features to `features`.
`void` | `setAutoFormatting(QTextEdit.AutoFormattingFlag... features)` Sets the enabled set of auto formatting features to `features`.
`void` | `setCurrentCharFormat(QTextCharFormat format)` Sets the char format that is be used when inserting new text to `format` by calling QTextCursor::setCharFormat() on the editor's cursor.
`void` | `setCurrentFont(QFont f)` Sets the font of the current format to `f`.
`void` | `setCursorWidth(int width)` This property specifies the width of the cursor in pixels.
`void` | `setDocument(QTextDocument document)` Makes `document` the new document of the text editor.
`void` | `setDocumentTitle(java.lang.String title)` Sets the title of the document parsed from the text.
`void` | `setExtraSelections(java.util.List<QTextEdit_ExtraSelection> selections)` This function allows temporarily marking certain regions in the document with a given color, specified as `selections`.
`void` | `setFontFamily(java.lang.String fontFamily)` Sets the font family of the current format to `fontFamily`.
`void` | `setFontItalic(boolean b)` If `b` is true, sets the current format to italic; otherwise sets the current format to non-italic.
`void` | `setFontPointSize(double s)` Sets the point size of the current format to `s`.
`void` | `setFontUnderline(boolean b)` If `b` is true, sets the current format to underline; otherwise sets the current format to non-underline.
`void` | `setFontWeight(int w)` Sets the font weight of the current format to the given `w`, where the value used is in the range defined by the QFont::Weight enum.
`void` | `setHtml(java.lang.String text)` This property provides an HTML interface to the text of the text edit.
`void` | `setLineWrapColumnOrWidth(int w)` Sets the position (in pixels or columns depending on the wrap mode) where text will be wrapped to `w`.
`void` | `setLineWrapMode(QTextEdit.LineWrapMode mode)` Sets the line wrap mode to `mode`.
`void` | `setOverwriteMode(boolean overwrite)` This property holds the text edit's overwrite mode to `overwrite`.
`void` | `setPlainText(java.lang.String text)` This property gets and sets the text edit's contents as plain text.
`void` | `setReadOnly(boolean ro)` Sets whether the text edit is read-only to `ro`.
`void` | `setTabChangesFocus(boolean b)` Sets whether Tab changes focus or is accepted as input to `b`.
`void` | `setTabStopWidth(int width)` Sets the tab stop width in pixels to `width`.
`void` | `setText(java.lang.String text)` Sets the text edit's `text`.
`void` | `setTextColor(QColor c)` Sets the text color of the current format to `c`.
`void` | `setTextCursor(QTextCursor cursor)` Sets the visible `cursor`.
`void` | `setTextInteractionFlags(Qt.TextInteractionFlag... flags)` Specifies how the label should interact with user input if it displays text.
`void` | `setTextInteractionFlags(Qt.TextInteractionFlags flags)` Specifies how the label should interact with user input if it displays text.
`void` | `setUndoRedoEnabled(boolean enable)` Sets whether undo and redo are enabled to `enable`.
`void` | `setWordWrapMode(QTextOption.WrapMode policy)` Sets the mode `QTextEdit` will use when wrapping text by words to `policy`.
`protected void` | `showEvent(QShowEvent arg__1)` This function is reimplemented for internal reasons.
`boolean` | `tabChangesFocus()` Returns whether Tab changes focus or is accepted as input.
`int` | `tabStopWidth()` Returns the tab stop width in pixels.
`QColor` | `textColor()` Returns the text color of the current format.
`QTextCursor` | `textCursor()` Returns a copy of the `QTextCursor` that represents the currently visible cursor.
`Qt.TextInteractionFlags` | `textInteractionFlags()` Specifies how the label should interact with user input if it displays text.
`protected void` | `timerEvent(QTimerEvent e)` This function is reimplemented for internal reasons.
`java.lang.String` | `toHtml()` This property provides an HTML interface to the text of the text edit.
`java.lang.String` | `toPlainText()` This property gets and sets the text edit's contents as plain text.
`void` | `undo()` Undoes the last operation.
`protected void` | `wheelEvent(QWheelEvent e)` This function is reimplemented for internal reasons.
`QTextOption.WrapMode` | `wordWrapMode()` Returns the mode `QTextEdit` will use when wrapping text by words.
`void` | `zoomIn()` Equivalent to `zoomIn`(1).
`void` | `zoomIn(int range)` Zooms in on the text by making the base font size `range` points larger and recalculating all font sizes to be the new size.
`void` | `zoomOut()` Equivalent to `zoomOut`(1).
`void` | `zoomOut(int range)` Zooms out on the text by making the base font size `range` points smaller and recalculating all font sizes to be the new size.

Methods inherited from class com.trolltech.qt.gui.QAbstractScrollArea
`addScrollBarWidget, addScrollBarWidget, cornerWidget, horizontalScrollBar, horizontalScrollBarPolicy, maximumViewportSize, minimumSizeHint, paintEngine, scrollBarWidgets, scrollBarWidgets, setCornerWidget, setHorizontalScrollBar, setHorizontalScrollBarPolicy, setupViewport, setVerticalScrollBar, setVerticalScrollBarPolicy, setViewport, setViewportMargins, sizeHint, verticalScrollBar, verticalScrollBarPolicy, viewport, viewportEvent`

Methods inherited from class com.trolltech.qt.gui.QFrame
`drawFrame, frameRect, frameShadow, frameShape, frameStyle, frameWidth, lineWidth, midLineWidth, setFrameRect, setFrameShadow, setFrameShape, setFrameStyle, setLineWidth, setMidLineWidth`

Methods inherited from class com.trolltech.qt.gui.QWidget
`acceptDrops, accessibleDescription, accessibleName, actionEvent, actions, activateWindow, addAction, addActions, adjustSize, autoFillBackground, backgroundRole, baseSize, childAt, childAt, childrenRect, childrenRegion, clearFocus, clearMask, close, closeEvent, contentsRect, contextMenuPolicy, createWinId, cursor, depth, destroy, destroy, destroy, devType, ensurePolished, enterEvent, focusNextChild, focusPolicy, focusPreviousChild, focusProxy, focusWidget, font, fontInfo, fontMetrics, foregroundRole, frameGeometry, frameSize, geometry, getContentsMargins, grabKeyboard, grabMouse, grabMouse, grabShortcut, grabShortcut, hasFocus, hasMouseTracking, height, heightForWidth, heightMM, hide, hideEvent, inputContext, insertAction, insertActions, isActiveWindow, isAncestorOf, isEnabled, isEnabledTo, isFullScreen, isHidden, isLeftToRight, isMaximized, isMinimized, isModal, isRightToLeft, isVisible, isVisibleTo, isWindow, isWindowModified, keyboardGrabber, layout, layoutDirection, leaveEvent, locale, logicalDpiX, logicalDpiY, lower, mapFrom, mapFromGlobal, mapFromParent, mapTo, mapToGlobal, mapToParent, mask, maximumHeight, maximumSize, maximumWidth, metric, minimumHeight, minimumSize, minimumWidth, mouseGrabber, move, move, moveEvent, nextInFocusChain, normalGeometry, numColors, overrideWindowFlags, overrideWindowFlags, overrideWindowState, overrideWindowState, paintingActive, palette, parentWidget, physicalDpiX, physicalDpiY, pos, raise, rect, releaseKeyboard, releaseMouse, releaseShortcut, removeAction, render, render, render, render, render, repaint, repaint, repaint, repaint, resetInputContext, resize, resize, restoreGeometry, saveGeometry, scroll, scroll, setAcceptDrops, setAccessibleDescription, setAccessibleName, setAttribute, setAttribute, setAutoFillBackground, setBackgroundRole, setBaseSize, setBaseSize, setContentsMargins, setContentsMargins, setContextMenuPolicy, setCursor, setDisabled, setEnabled, setFixedHeight, setFixedSize, setFixedSize, setFixedWidth, setFocus, setFocus, setFocusPolicy, setFocusProxy, setFont, setForegroundRole, setGeometry, setGeometry, setHidden, setInputContext, setLayout, setLayoutDirection, setLocale, setMask, setMask, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setMouseTracking, setPalette, setParent, setParent, setParent, setShortcutAutoRepeat, setShortcutAutoRepeat, setShortcutEnabled, setShortcutEnabled, setSizeIncrement, setSizeIncrement, setSizePolicy, setSizePolicy, setStatusTip, setStyle, setStyleSheet, setTabOrder, setToolTip, setUpdatesEnabled, setVisible, setWhatsThis, setWindowFlags, setWindowFlags, setWindowIcon, setWindowIconText, setWindowModality, setWindowModified, setWindowOpacity, setWindowRole, setWindowState, setWindowState, setWindowTitle, show, showFullScreen, showMaximized, showMinimized, showNormal, size, sizeIncrement, sizePolicy, stackUnder, statusTip, style, styleSheet, tabletEvent, testAttribute, toolTip, underMouse, unsetCursor, unsetLayoutDirection, unsetLocale, update, update, update, update, updateGeometry, updateMicroFocus, updatesEnabled, visibleRegion, whatsThis, width, widthMM, window, windowFlags, windowIcon, windowIconText, windowModality, windowOpacity, windowRole, windowState, windowTitle, windowType, winId, x, y`

Methods inherited from class com.trolltech.qt.core.QObject
`blockSignals, childEvent, children, connectSlotsByName, customEvent, disposeLater, dumpObjectInfo, dumpObjectTree, dynamicPropertyNames, eventFilter, findChild, findChild, findChild, findChildren, findChildren, findChildren, findChildren, installEventFilter, isWidgetType, killTimer, moveToThread, objectName, parent, property, removeEventFilter, setObjectName, setParent, setProperty, signalsBlocked, startTimer, thread`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`disconnect, disconnect, signalSender`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Field Detail

### copyAvailable

    public final QSignalEmitter.Signal1<java.lang.Boolean> copyAvailable

  This signal is emitted when text is selected or de-selected in the text edit.

  When text is selected this signal will be emitted with `b` set to true. If no text has been selected or if the selected text is de-selected this signal is emitted with `b` set to false.

  If `b` is true then `copy` can be used to copy the selection to the clipboard. If `b` is false then `copy` does nothing.

  Compatible Slot Signatures:
    `void mySlot(boolean b)`
    `void mySlot()`
  See Also:
    `selectionChanged`

### currentCharFormatChanged

    public final QSignalEmitter.Signal1<QTextCharFormat> currentCharFormatChanged

  This signal is emitted if the current character format has changed, for example caused by a change of the cursor position.

  The new format is `format`.

  Compatible Slot Signatures:
    `void mySlot(com.trolltech.qt.gui.QTextCharFormat format)`
    `void mySlot()`
  See Also:
    `setCurrentCharFormat`

### cursorPositionChanged

    public final QSignalEmitter.Signal0 cursorPositionChanged

  This signal is emitted whenever the position of the cursor changed.

  Compatible Slot Signature:
    `void mySlot()`

### redoAvailable

    public final QSignalEmitter.Signal1<java.lang.Boolean> redoAvailable

  This signal is emitted whenever redo operations become available (`b` is true) or unavailable (`b` is false).

  Compatible Slot Signatures:
    `void mySlot(boolean b)`
    `void mySlot()`

### selectionChanged

    public final QSignalEmitter.Signal0 selectionChanged

  This signal is emitted whenever the selection changes.

  Compatible Slot Signature:
    `void mySlot()`
  See Also:
    `copyAvailable`

### textChanged

    public final QSignalEmitter.Signal0 textChanged

  This signal is emitted whenever the document's content changes; for example, when text is inserted or deleted, or when formatting is applied.

  Compatible Slot Signature:
    `void mySlot()`

### undoAvailable

    public final QSignalEmitter.Signal1<java.lang.Boolean> undoAvailable

  This signal is emitted whenever undo operations become available (`b` is true) or unavailable (`b` is false).

  Compatible Slot Signatures:
    `void mySlot(boolean b)`
    `void mySlot()`

Constructor Detail

### QTextEdit

    public QTextEdit()

  Equivalent to `QTextEdit`(0).

### QTextEdit

    public QTextEdit(QWidget parent)

  Constructs an empty `QTextEdit` with parent `parent`.

### QTextEdit

    public QTextEdit(java.lang.String text)

  Equivalent to `QTextEdit`(`text`, 0).

### QTextEdit

    public QTextEdit(java.lang.String text,
                     QWidget parent)

  Constructs a `QTextEdit` with parent `parent`. The text edit will display the text `text`. The text is interpreted as html.

Method Detail

### acceptRichText

    public final boolean acceptRichText()

  Returns whether the text edit accepts rich text insertions by the user.

  When this propery is set to false text edit will accept only plain text input from the user. For example through clipboard or drag and drop.

  This property's default is true.

  See Also:
    `setAcceptRichText`

### alignment

    public final Qt.Alignment alignment()

  Returns the alignment of the current paragraph.

  See Also:
    `setAlignment`

### anchorAt

    public final java.lang.String anchorAt(QPoint pos)

  Returns the reference of the anchor at position `pos`, or an empty string if no anchor exists at that point.

### append

    public final void append(java.lang.String text)

  Appends a new paragraph with `text` to the end of the text edit.

  Note: The new paragraph appended will have the same character format and block format as the current paragraph, determined by the position of the cursor.

  See Also:
    `currentCharFormat`, `QTextCursor::blockFormat`

### autoFormatting

    public final QTextEdit.AutoFormatting autoFormatting()

  Returns the enabled set of auto formatting features.

  The value can be any combination of the values in the `AutoFormattingFlag` enum. The default is `AutoNone`. Choose `AutoAll` to enable all automatic formatting.

  Currently, the only automatic formatting feature provided is `AutoBulletList`; future versions of Qt may offer more.

  See Also:
    `setAutoFormatting`

### canPaste

    public final boolean canPaste()

  Returns whether text can be pasted from the clipboard into the textedit.

### clear

    public final void clear()

  Deletes all the text in the text edit.

  Note that the undo/redo history is cleared by this function.

  See Also:
    `cut`, `setPlainText`, `setHtml`

### copy

    public final void copy()

  Copies any selected text to the clipboard.

  See Also:
    `copyAvailable`

### createStandardContextMenu

    public final QMenu createStandardContextMenu()

  This function creates the standard context menu which is shown when the user clicks on the line edit with the right mouse button. It is called from the default `contextMenuEvent` handler. The popup menu's ownership is transferred to the caller.

### currentCharFormat

    public final QTextCharFormat currentCharFormat()

  Returns the char format that is used when inserting new text.

  See Also:
    `setCurrentCharFormat`

### currentFont

    public final QFont currentFont()

  Returns the font of the current format.

  See Also:
    `setCurrentFont`, `setFontFamily`, `setFontPointSize`

### cursorForPosition

    public final QTextCursor cursorForPosition(QPoint pos)

  returns a `QTextCursor` at position `pos` (in viewport coordinates).

### cursorRect

    public final QRect cursorRect(QTextCursor cursor)

  returns a rectangle (in viewport coordinates) that includes the `cursor`.

### cursorRect

    public final QRect cursorRect()

  returns a rectangle (in viewport coordinates) that includes the cursor of the text edit.

### cursorWidth

    public final int cursorWidth()

  This property specifies the width of the cursor in pixels. The default value is 1.

  See Also:
    `setCursorWidth`

### cut

    public final void cut()

  Copies the selected text to the clipboard and deletes it from the text edit.

  If there is no selected text nothing happens.

  See Also:
    `copy`, `paste`

### document

    public final QTextDocument document()

  Returns a pointer to the underlying document.

  See Also:
    `setDocument`

### documentTitle

    public final java.lang.String documentTitle()

  Returns the title of the document parsed from the text..

  See Also:
    `setDocumentTitle`

### ensureCursorVisible

    public final void ensureCursorVisible()

  Ensures that the cursor is visible by scrolling the text edit if necessary.

### extraSelections

    public final java.util.List<QTextEdit_ExtraSelection> extraSelections()

  Returns previously set extra selections.

  See Also:
    `setExtraSelections`

### find

    public final boolean find(java.lang.String exp,
                              QTextDocument.FindFlag... options)

  Finds the next occurrence of the string, `exp`, using the given `options`. Returns true if `exp` was found and changes the cursor to select the match; otherwise returns false.

### find

    public final boolean find(java.lang.String exp)

  Equivalent to find(`exp`, 0).

### find

    public final boolean find(java.lang.String exp,
                              QTextDocument.FindFlags options)

  Finds the next occurrence of the string, `exp`, using the given `options`. Returns true if `exp` was found and changes the cursor to select the match; otherwise returns false.

### fontFamily

    public final java.lang.String fontFamily()

  Returns the font family of the current format.

  See Also:
    `setFontFamily`, `setCurrentFont`, `setFontPointSize`

### fontItalic

    public final boolean fontItalic()

  Returns true if the font of the current format is italic; otherwise returns false.

  See Also:
    `setFontItalic`

### fontPointSize

    public final double fontPointSize()

  Returns the point size of the font of the current format.

  See Also:
    `setFontFamily`, `setCurrentFont`, `setFontPointSize`

### fontUnderline

    public final boolean fontUnderline()

  Returns true if the font of the current format is underlined; otherwise returns false.

  See Also:
    `setFontUnderline`

### fontWeight

    public final int fontWeight()

  Returns the font weight of the current format.

  See Also:
    `setFontWeight`, `setCurrentFont`, `setFontPointSize`, `QFont::Weight`

### insertHtml

    public final void insertHtml(java.lang.String text)

  Convenience slot that inserts `text` which is assumed to be of html formatting at the current cursor position.

  It is equivalent to:

          edit->textCursor().insertHtml(fragment);

  Note: When using this function with a style sheet, the style sheet will only apply to the current block in the document. In order to apply a style sheet throughout a document, use QTextDocument::setDefaultStyleSheet() instead.

### insertPlainText

    public final void insertPlainText(java.lang.String text)

  Convenience slot that inserts `text` at the current cursor position.

  It is equivalent to

          edit->textCursor().insertText(text);

### isReadOnly

    public final boolean isReadOnly()

  Returns whether the text edit is read-only.

  In a read-only text edit the user can only navigate through the text and select text; modifying the text is not possible.

  This property's default is false.

### isUndoRedoEnabled

    public final boolean isUndoRedoEnabled()

  Returns whether undo and redo are enabled.

  Users are only able to undo or redo actions if this property is true, and if there is an action that can be undone (or redone).

### lineWrapColumnOrWidth

    public final int lineWrapColumnOrWidth()

  Returns the position (in pixels or columns depending on the wrap mode) where text will be wrapped.

  If the wrap mode is `FixedPixelWidth`, the value is the number of pixels from the left edge of the text edit at which text should be wrapped. If the wrap mode is `FixedColumnWidth`, the value is the column number (in character columns) from the left edge of the text edit at which text should be wrapped.

  See Also:
    `setLineWrapColumnOrWidth`, `lineWrapMode`

### lineWrapMode

    public final QTextEdit.LineWrapMode lineWrapMode()

  Returns the line wrap mode.

  The default mode is `WidgetWidth` which causes words to be wrapped at the right edge of the text edit. Wrapping occurs at whitespace, keeping whole words intact. If you want wrapping to occur within words use `setWordWrapMode`. If you set a wrap mode of `FixedPixelWidth` or `FixedColumnWidth` you should also call `setLineWrapColumnOrWidth` with the width you want.

  See Also:
    `setLineWrapMode`, `lineWrapColumnOrWidth`

### mergeCurrentCharFormat

    public final void mergeCurrentCharFormat(QTextCharFormat modifier)

  Merges the properties specified in `modifier` into the current character format by calling QTextCursor::mergeCharFormat on the editor's cursor. If the editor has a selection then the properties of `modifier` are directly applied to the selection.

  See Also:
    `QTextCursor::mergeCharFormat`

### moveCursor

    public final void moveCursor(QTextCursor.MoveOperation operation)

  Equivalent to `moveCursor`(`operation`, QTextCursor::MoveAnchor).

### moveCursor

    public final void moveCursor(QTextCursor.MoveOperation operation,
                                 QTextCursor.MoveMode mode)

  Moves the cursor by performing the given `operation`.

  If `mode` is QTextCursor::KeepAnchor, the cursor selects the text it moves over. This is the same effect that the user achieves when they hold down the Shift key and move the cursor with the cursor keys.

  See Also:
    `QTextCursor::movePosition`

### overwriteMode

    public final boolean overwriteMode()

  Returns this QTextEdit's overwrite mode.

  If FALSE (the default) characters entered by the user are inserted with any characters to the right being moved out of the way. If TRUE, the editor is in overwrite mode, i.e. characters entered by the user overwrite any characters to the right of the cursor position.

### paste

    public final void paste()

  Pastes the text from the clipboard into the text edit at the current cursor position.

  If there is no text in the clipboard nothing happens.

  To change the behavior of this function, i.e. to modify what `QTextEdit` can paste and how it is being pasted, reimplement the virtual `canInsertFromMimeData` and `insertFromMimeData` functions.

  See Also:
    `cut`, `copy`

### print

    public final void print(QPrinter printer)

  Convenience function to print the text edit's document to the given `printer`. This is equivalent to calling the print method on the document directly except that this function also supports QPrinter::Selection as print range.

  See Also:
    `QTextDocument::print`

### redo

    public final void redo()

  Redoes the last operation.

  If there is no operation to redo, i.e. there is no redo step in the undo/redo history, nothing happens.

  See Also:
    `undo`

### scrollToAnchor

    public final void scrollToAnchor(java.lang.String name)

  Scrolls the text edit so that the anchor with the given `name` is visible; does nothing if the `name` is empty, or is already visible, or isn't found.

### selectAll

    public final void selectAll()

  Selects all text.

  See Also:
    `copy`, `cut`, `textCursor`

### setAcceptRichText

    public final void setAcceptRichText(boolean accept)

  Sets whether the text edit accepts rich text insertions by the user to `accept`.

  When this propery is set to false text edit will accept only plain text input from the user. For example through clipboard or drag and drop.

  This property's default is true.

  See Also:
    `acceptRichText`

### setAlignment

    public final void setAlignment(Qt.AlignmentFlag... a)

  Sets the alignment of the current paragraph to `a`. Valid alignments are Qt::AlignLeft, Qt::AlignRight, Qt::AlignJustify and Qt::AlignCenter (which centers horizontally).

  See Also:
    `alignment`

### setAlignment

    public final void setAlignment(Qt.Alignment a)

  Sets the alignment of the current paragraph to `a`. Valid alignments are Qt::AlignLeft, Qt::AlignRight, Qt::AlignJustify and Qt::AlignCenter (which centers horizontally).

  See Also:
    `alignment`

### setAutoFormatting

    public final void setAutoFormatting(QTextEdit.AutoFormattingFlag... features)

  Sets the enabled set of auto formatting features to `features`.

  The value can be any combination of the values in the `AutoFormattingFlag` enum. The default is `AutoNone`. Choose `AutoAll` to enable all automatic formatting.

  Currently, the only automatic formatting feature provided is `AutoBulletList`; future versions of Qt may offer more.

  See Also:
    `autoFormatting`

### setAutoFormatting

    public final void setAutoFormatting(QTextEdit.AutoFormatting features)

  Sets the enabled set of auto formatting features to `features`.

  The value can be any combination of the values in the `AutoFormattingFlag` enum. The default is `AutoNone`. Choose `AutoAll` to enable all automatic formatting.

  Currently, the only automatic formatting feature provided is `AutoBulletList`; future versions of Qt may offer more.

  See Also:
    `autoFormatting`

### setCurrentCharFormat

    public final void setCurrentCharFormat(QTextCharFormat format)

  Sets the char format that is be used when inserting new text to `format` by calling QTextCursor::setCharFormat() on the editor's cursor. If the editor has a selection then the char format is directly applied to the selection.

  See Also:
    `currentCharFormat`

### setCurrentFont

    public final void setCurrentFont(QFont f)

  Sets the font of the current format to `f`.

  See Also:
    `currentFont`, `setFontPointSize`, `setFontFamily`

### setCursorWidth

    public final void setCursorWidth(int width)

  This property specifies the width of the cursor in pixels. The default value is 1.

  See Also:
    `cursorWidth`

### setDocument

    public final void setDocument(QTextDocument document)

  Makes `document` the new document of the text editor.

  The parent `QObject` of the provided document remains the owner of the object. If the current document is a child of the text editor, then it is deleted.

  See Also:
    `document`

### setDocumentTitle

    public final void setDocumentTitle(java.lang.String title)

  Sets the title of the document parsed from the text. to `title`.

  See Also:
    `documentTitle`

### setExtraSelections

    public final void setExtraSelections(java.util.List<QTextEdit_ExtraSelection> selections)

  This function allows temporarily marking certain regions in the document with a given color, specified as `selections`. This can be useful for example in a programming editor to mark a whole line of text with a given background color to indicate the existence of a breakpoint.

  See Also:
    `QTextEdit::ExtraSelection`, `extraSelections`

### setFontFamily

    public final void setFontFamily(java.lang.String fontFamily)

  Sets the font family of the current format to `fontFamily`.

  See Also:
    `fontFamily`, `setCurrentFont`

### setFontItalic

    public final void setFontItalic(boolean b)

  If `b` is true, sets the current format to italic; otherwise sets the current format to non-italic.

  See Also:
    `fontItalic`

### setFontPointSize

    public final void setFontPointSize(double s)

  Sets the point size of the current format to `s`.

  Note that if `s` is zero or negative, the behavior of this function is not defined.

  See Also:
    `fontPointSize`, `setCurrentFont`, `setFontFamily`

### setFontUnderline

    public final void setFontUnderline(boolean b)

  If `b` is true, sets the current format to underline; otherwise sets the current format to non-underline.

  See Also:
    `fontUnderline`

### setFontWeight

    public final void setFontWeight(int w)

  Sets the font weight of the current format to the given `w`, where the value used is in the range defined by the QFont::Weight enum.

  See Also:
    `fontWeight`, `setCurrentFont`, `setFontFamily`

### setHtml

    public final void setHtml(java.lang.String text)

  This property provides an HTML interface to the text of the text edit.

  `toHtml` returns the text of the text edit as html.

  `setHtml` changes the text of the text edit. Any previous text is removed and the undo/redo history is cleared. The input text is interpreted as rich text in html format.

  Note: It is the responsibility of the caller to make sure that the text is correctly decoded when a `QString` containing HTML is created and passed to `setHtml`.

  See Also:
    Supported HTML Subset, `plainText`

### setLineWrapColumnOrWidth

    public final void setLineWrapColumnOrWidth(int w)

  Sets the position (in pixels or columns depending on the wrap mode) where text will be wrapped to `w`.

  If the wrap mode is `FixedPixelWidth`, the value is the number of pixels from the left edge of the text edit at which text should be wrapped. If the wrap mode is `FixedColumnWidth`, the value is the column number (in character columns) from the left edge of the text edit at which text should be wrapped.

  See Also:
    `lineWrapColumnOrWidth`, `lineWrapMode`

### setLineWrapMode

    public final void setLineWrapMode(QTextEdit.LineWrapMode mode)

  Sets the line wrap mode to `mode`.

  The default mode is `WidgetWidth` which causes words to be wrapped at the right edge of the text edit. Wrapping occurs at whitespace, keeping whole words intact. If you want wrapping to occur within words use `setWordWrapMode`. If you set a wrap mode of `FixedPixelWidth` or `FixedColumnWidth` you should also call `setLineWrapColumnOrWidth` with the width you want.

  See Also:
    `lineWrapMode`, `lineWrapColumnOrWidth`

### setOverwriteMode

    public final void setOverwriteMode(boolean overwrite)

  This property holds the text edit's overwrite mode to `overwrite`.

  If FALSE (the default) characters entered by the user are inserted with any characters to the right being moved out of the way. If TRUE, the editor is in overwrite mode, i.e. characters entered by the user overwrite any characters to the right of the cursor position.

### setPlainText

    public final void setPlainText(java.lang.String text)

  This property gets and sets the text edit's contents as plain text. Previous contents are removed and undo/redo history is reset when the property is set. If the text edit has another content type, it will not be replaced by plain text when you call `toPlainText`.

  See Also:
    `html`

### setReadOnly

    public final void setReadOnly(boolean ro)

  Sets whether the text edit is read-only to `ro`.

  In a read-only text edit the user can only navigate through the text and select text; modifying the text is not possible.

  This property's default is false.

  See Also:
    `isReadOnly`

### setTabChangesFocus

    public final void setTabChangesFocus(boolean b)

  Sets whether Tab changes focus or is accepted as input to `b`.

  In some occasions text edits should not allow the user to input tabulators or change indentation using the Tab key, as this breaks the focus chain. The default is false.

  See Also:
    `tabChangesFocus`

### setTabStopWidth

    public final void setTabStopWidth(int width)

  Sets the tab stop width in pixels to `width`.

  See Also:
    `tabStopWidth`

### setText

    public final void setText(java.lang.String text)

  Sets the text edit's `text`. The text can be plain text or HTML and the text edit will try to guess the right format.

  Use `setHtml` or `setPlainText` directly to avoid text edit's guessing.

### setTextColor

    public final void setTextColor(QColor c)

  Sets the text color of the current format to `c`.

  See Also:
    `textColor`

### setTextCursor

    public final void setTextCursor(QTextCursor cursor)

  Sets the visible `cursor`.

  See Also:
    `textCursor`

### setTextInteractionFlags

    public final void setTextInteractionFlags(Qt.TextInteractionFlag... flags)

  Specifies how the label should interact with user input if it displays text.

  If the flags contain either Qt::LinksAccessibleByKeyboard or Qt::TextSelectableByKeyboard then the focus policy is also automatically set to Qt::ClickFocus.

  The default value depends on whether the `QTextEdit` is read-only or editable, and whether it is a `QTextBrowser` or not.

  See Also:
    `textInteractionFlags`

### setTextInteractionFlags

    public final void setTextInteractionFlags(Qt.TextInteractionFlags flags)

  Specifies how the label should interact with user input if it displays text.

  If the flags contain either Qt::LinksAccessibleByKeyboard or Qt::TextSelectableByKeyboard then the focus policy is also automatically set to Qt::ClickFocus.

  The default value depends on whether the `QTextEdit` is read-only or editable, and whether it is a `QTextBrowser` or not.

  See Also:
    `textInteractionFlags`

### setUndoRedoEnabled

    public final void setUndoRedoEnabled(boolean enable)

  Sets whether undo and redo are enabled to `enable`.

  Users are only able to undo or redo actions if this property is true, and if there is an action that can be undone (or redone).

  See Also:
    `isUndoRedoEnabled`

### setWordWrapMode

    public final void setWordWrapMode(QTextOption.WrapMode policy)

  Sets the mode `QTextEdit` will use when wrapping text by words to `policy`.

  See Also:
    `wordWrapMode`, `QTextOption::WrapMode`

### tabChangesFocus

    public final boolean tabChangesFocus()

  Returns whether Tab changes focus or is accepted as input.

  In some occasions text edits should not allow the user to input tabulators or change indentation using the Tab key, as this breaks the focus chain. The default is false.

  See Also:
    `setTabChangesFocus`

### tabStopWidth

    public final int tabStopWidth()

  Returns the tab stop width in pixels.

  See Also:
    `setTabStopWidth`

### textColor

    public final QColor textColor()

  Returns the text color of the current format.

  See Also:
    `setTextColor`

### textCursor

    public final QTextCursor textCursor()

  Returns a copy of the `QTextCursor` that represents the currently visible cursor. Note that changes on the returned cursor do not affect `QTextEdit`'s cursor; use `setTextCursor` to update the visible cursor.

  See Also:
    `setTextCursor`

### textInteractionFlags

    public final Qt.TextInteractionFlags textInteractionFlags()

  Specifies how the label should interact with user input if it displays text.

  If the flags contain either Qt::LinksAccessibleByKeyboard or Qt::TextSelectableByKeyboard then the focus policy is also automatically set to Qt::ClickFocus.

  The default value depends on whether the `QTextEdit` is read-only or editable, and whether it is a `QTextBrowser` or not.

  See Also:
    `setTextInteractionFlags`

### toHtml

    public final java.lang.String toHtml()

  This property provides an HTML interface to the text of the text edit.

  `toHtml` returns the text of the text edit as html.

  `setHtml` changes the text of the text edit. Any previous text is removed and the undo/redo history is cleared. The input text is interpreted as rich text in html format.

  Note: It is the responsibility of the caller to make sure that the text is correctly decoded when a `QString` containing HTML is created and passed to `setHtml`.

  See Also:
    Supported HTML Subset, `plainText`

### toPlainText

    public final java.lang.String toPlainText()

  This property gets and sets the text edit's contents as plain text. Previous contents are removed and undo/redo history is reset when the property is set. If the text edit has another content type, it will not be replaced by plain text when you call `toPlainText`.

  See Also:
    `html`

### undo

    public final void undo()

  Undoes the last operation.

  If there is no operation to undo, i.e. there is no undo step in the undo/redo history, nothing happens.

  See Also:
    `redo`

### wordWrapMode

    public final QTextOption.WrapMode wordWrapMode()

  Returns the mode `QTextEdit` will use when wrapping text by words.

  See Also:
    `setWordWrapMode`, `QTextOption::WrapMode`

### zoomIn

    public final void zoomIn()

  Equivalent to `zoomIn`(1).

### zoomIn

    public final void zoomIn(int range)

  Zooms in on the text by making the base font size `range` points larger and recalculating all font sizes to be the new size. This does not change the size of any images.

  See Also:
    `zoomOut`

### zoomOut

    public final void zoomOut()

  Equivalent to `zoomOut`(1).

### zoomOut

    public final void zoomOut(int range)

  Zooms out on the text by making the base font size `range` points smaller and recalculating all font sizes to be the new size. This does not change the size of any images.

  See Also:
    `zoomIn`

### canInsertFromMimeData

    protected boolean canInsertFromMimeData(QMimeData source)

  This function returns true if the contents of the MIME data object, specified by `source`, can be decoded and inserted into the document. It is called for example when during a drag operation the mouse enters this widget and it is necessary to determine whether it is possible to accept the drag and drop operation.

  Reimplement this function to enable drag and drop support for additional MIME types.

### changeEvent

    protected void changeEvent(QEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `changeEvent` in class `QFrame`

### contextMenuEvent

    protected void contextMenuEvent(QContextMenuEvent e)

  Shows the standard context menu created with `createStandardContextMenu`.

  If you do not want the text edit to have a context menu, you can set its `contextMenuPolicy` to Qt::NoContextMenu. If you want to customize the context menu, reimplement this function. If you want to extend the standard context menu, reimplement this function, call `createStandardContextMenu` and extend the menu returned.

  Information about the event is passed in the `e` object.

          void MyTextEdit::contextMenuEvent(QContextMenuEvent *event)
          {
              QMenu *menu = createStandardContextMenu();
              menu->addAction(tr("My Menu Item"));
              //...
              menu->exec(event->globalPos());
              delete menu;
          }

  Overrides:
    `contextMenuEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::contextMenuEvent`

### createMimeDataFromSelection

    protected QMimeData createMimeDataFromSelection()

  This function returns a new MIME data object to represent the contents of the text edit's current selection. It is called when the selection needs to be encapsulated into a new `QMimeData` object; for example, when a drag and drop operation is started, or when data is copyied to the clipboard.

  If you reimplement this function, note that the ownership of the returned `QMimeData` object is passed to the caller. The selection can be retrieved by using the `textCursor` function.

### dragEnterEvent

    protected void dragEnterEvent(QDragEnterEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `dragEnterEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::dragEnterEvent`

### dragLeaveEvent

    protected void dragLeaveEvent(QDragLeaveEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `dragLeaveEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::dragLeaveEvent`

### dragMoveEvent

    protected void dragMoveEvent(QDragMoveEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `dragMoveEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::dragMoveEvent`

### dropEvent

    protected void dropEvent(QDropEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `dropEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::dropEvent`

### event

    public boolean event(QEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `event` in class `QAbstractScrollArea`
  See Also:
    `QEvent::type`

### focusInEvent

    protected void focusInEvent(QFocusEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `focusInEvent` in class `QWidget`
  See Also:
    `focusOutEvent`, `setFocusPolicy`, `keyPressEvent`, `keyReleaseEvent`, `event`, `QFocusEvent`

### focusNextPrevChild

    protected boolean focusNextPrevChild(boolean next)

  This function is reimplemented for internal reasons.

  Overrides:
    `focusNextPrevChild` in class `QWidget`
  See Also:
    `focusNextChild`, `focusPreviousChild`

### focusOutEvent

    protected void focusOutEvent(QFocusEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `focusOutEvent` in class `QWidget`
  See Also:
    `focusInEvent`, `setFocusPolicy`, `keyPressEvent`, `keyReleaseEvent`, `event`, `QFocusEvent`

### inputMethodEvent

    protected void inputMethodEvent(QInputMethodEvent arg__1)

  This function is reimplemented for internal reasons.

  Overrides:
    `inputMethodEvent` in class `QWidget`
  See Also:
    `event`, `QInputMethodEvent`

### inputMethodQuery

    public java.lang.Object inputMethodQuery(Qt.InputMethodQuery property)

  This function is reimplemented for internal reasons.

  Overrides:
    `inputMethodQuery` in class `QWidget`
  See Also:
    `inputMethodEvent`, `QInputMethodEvent`, `QInputContext`

### insertFromMimeData

    protected void insertFromMimeData(QMimeData source)

  This function inserts the contents of the MIME data object, specified by `source`, into the text edit at the current cursor position. It is called whenever text is inserted as the result of a clipboard paste operation, or when the text edit accepts data from a drag and drop operation.

  Reimplement this function to enable drag and drop support for additional MIME types.

### keyPressEvent

    protected void keyPressEvent(QKeyEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `keyPressEvent` in class `QAbstractScrollArea`
  See Also:
    `keyReleaseEvent`, `QKeyEvent::ignore`, `setFocusPolicy`, `focusInEvent`, `focusOutEvent`, `event`, `QKeyEvent`, Tetrix Example

### keyReleaseEvent

    protected void keyReleaseEvent(QKeyEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `keyReleaseEvent` in class `QWidget`
  See Also:
    `keyPressEvent`, `QKeyEvent::ignore`, `setFocusPolicy`, `focusInEvent`, `focusOutEvent`, `event`, `QKeyEvent`

### loadResource

    public java.lang.Object loadResource(int type,
                                         QUrl name)

  Loads the resource specified by the given `type` and `name`.

  This function is an extension of QTextDocument::loadResource().

  See Also:
    `QTextDocument::loadResource`

### mouseDoubleClickEvent

    protected void mouseDoubleClickEvent(QMouseEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `mouseDoubleClickEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::mouseDoubleClickEvent`

### mouseMoveEvent

    protected void mouseMoveEvent(QMouseEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `mouseMoveEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::mouseMoveEvent`

### mousePressEvent

    protected void mousePressEvent(QMouseEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `mousePressEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::mousePressEvent`

### mouseReleaseEvent

    protected void mouseReleaseEvent(QMouseEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `mouseReleaseEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::mouseReleaseEvent`

### paintEvent

    protected void paintEvent(QPaintEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `paintEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::paintEvent`

### resizeEvent

    protected void resizeEvent(QResizeEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `resizeEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::resizeEvent`

### scrollContentsBy

    protected void scrollContentsBy(int dx,
                                    int dy)

  This function is reimplemented for internal reasons.

  Overrides:
    `scrollContentsBy` in class `QAbstractScrollArea`

### showEvent

    protected void showEvent(QShowEvent arg__1)

  This function is reimplemented for internal reasons.

  Overrides:
    `showEvent` in class `QWidget`
  See Also:
    `visible`, `event`, `QShowEvent`

### timerEvent

    protected void timerEvent(QTimerEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `timerEvent` in class `QObject`
  See Also:
    `startTimer`, `killTimer`, `event`

### wheelEvent

    protected void wheelEvent(QWheelEvent e)

  This function is reimplemented for internal reasons.

  Overrides:
    `wheelEvent` in class `QAbstractScrollArea`
  See Also:
    `QWidget::wheelEvent`

### fromNativePointer

    public static QTextEdit fromNativePointer(QNativePointer nativePointer)

  This function returns the QTextEdit instance pointed to by nativePointer

  Parameters:
    `nativePointer` - the QNativePointer of which object should be returned.

Overview | Package | Class | Tree | Deprecated | Index | Help
Qt Jambi Home |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD